/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.tipo_egreso;

import danielcortes.xyz.data.SQLiteConnectionHolder;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteTipoEgresoDAO extends TipoEgresoDAO {
    private static final Logger LOGGER = Logger.getLogger(SQLiteTipoEgresoDAO.class.getName());

    public SQLiteTipoEgresoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<TipoEgreso> findAll() {
        List<TipoEgreso> tipoEgresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from tipos_egreso";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            tipoEgresoList = this.tipoEgresoFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return tipoEgresoList;
    }

    @Override
    public List<TipoEgreso> findById(int id) {
        List<TipoEgreso> tipoEgresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from tipos_egreso where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            tipoEgresoList = this.tipoEgresoFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return tipoEgresoList;
    }

    @Override
    public List<TipoEgreso> findByNombre(String nombre) {
        List<TipoEgreso> tipoEgresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from tipos_egreso where nombre = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, nombre);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, nombre});

            tipoEgresoList = this.tipoEgresoFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return tipoEgresoList;
    }
}
